function pb=init(name,datadir,endian,psav)

% initialize variables to read in data from a problem
  
  % name
    
  pb.name = name;  
  
  % data directory
  
  pb.datadir = datadir;
  
  % endian
  
  if nargin<3
    pb.endian = 'n';
  else
    pb.endian = endian;
  end
  
  % precision of data to be read in

  if nargin<4
    psav = 4;
  end

  switch psav
   case 4
    pb.pre = '''real*4''';
   case 8
    pb.pre = '''real*8''';
  end
  
  % base file name

  pb.f00 = [pb.datadir,deblank(pb.name)];
  
  % load basic problem data
  
  [f m] = fopen([pb.f00,'.m',],'r');
  if ~isempty(m);disp(m);end
  if f==-1;return;end
  while 1
    txt = fgetl(f);
    if txt==-1; break; end
    eval(['pb.',txt])
  end
  fclose(f);
  
  % skip space between data values (needed with Fortran binary data output format)

  readspace = 'fread(f,1,''integer*4'');';
  
  % read base time vector
  
  [f m] = fopen([pb.f00,'_time','.dat'],'r',pb.endian);
  if ~isempty(m);disp(m);end
  if f==-1;return;end
  
  n = 0;
  while n<1e6
    n = n+1;
    eval(readspace);
    eval(['pb.t(n) = fread(f,1,',pb.pre,');'],'');
    eval(readspace);
    if n>length(pb.t)
      n = n-1;
      break
    end
  end

  fclose(f);

