! MDSBI version 3.9.10 -- Multi-Dimensional Spectral Boundary Integral Code
module mpi

  use constants, only : pr,pin

  implicit none

  interface MPI_Bcast
     module procedure MPI_Bcast_character,MPI_Bcast_logical,MPI_Bcast_integer, &
          MPI_Bcast_real,MPI_Bcast_real_vector
  end interface

  interface MPI_Gatherv
     module procedure MPI_Gatherv_real,MPI_Gatherv_complex
  end interface

  interface MPI_Scatterv
     module procedure MPI_Scatterv_real,MPI_Scatterv_complex
  end interface

  integer,parameter :: MPI_LOGICAL=0,MPI_CHARACTER=0, &
       MPI_INTEGER=0, &
       MPI_REAL=0,MPI_DOUBLE_PRECISION=0, &
       MPI_COMPLEX=0,MPI_DOUBLE_COMPLEX=0, &
       MPI_COMM_WORLD=0, &
       MPI_MAX=0

contains


  subroutine MPI_Init(ierror)
    
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Init


  subroutine MPI_Finalize(ierror)
    
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Finalize


  subroutine MPI_Comm_Rank(comm,rank,ierror)
    
    integer(pin),intent(in) :: comm
    integer(pin),intent(out) :: rank,ierror

    rank = 0
    ierror = 0

  end subroutine MPI_Comm_Rank


  subroutine MPI_Comm_Size(comm,size,ierror)
    
    integer(pin),intent(in) :: comm
    integer(pin),intent(out) :: size,ierror

    size = 1
    ierror = 0

  end subroutine MPI_Comm_Size


  subroutine MPI_Barrier(comm,ierror)
    
    integer(pin),intent(in) :: comm
    integer(pin),intent(out) :: ierror
    
    ierror = 0

  end subroutine MPI_Barrier


  function MPI_WTime() result(t)

    use constants, only : zero

    real(pr) :: t

    t = zero

  end function MPI_WTime


  subroutine MPI_Bcast_character(buffer,count,datatype,root,comm,ierror)
    
    character(*),intent(in) :: buffer
    integer(pin),intent(in) :: count,datatype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Bcast_character


  subroutine MPI_Bcast_logical(buffer,count,datatype,root,comm,ierror)
    
    logical,intent(in) :: buffer
    integer(pin),intent(in) :: count,datatype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Bcast_logical


  subroutine MPI_Bcast_integer(buffer,count,datatype,root,comm,ierror)
    
    integer(pin),intent(in) :: buffer
    integer(pin),intent(in) :: count,datatype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Bcast_integer


  subroutine MPI_Bcast_real(buffer,count,datatype,root,comm,ierror)
    
    real(pr),intent(in) :: buffer
    integer(pin),intent(in) :: count,datatype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Bcast_real


  subroutine MPI_Bcast_real_vector(buffer,count,datatype,root,comm,ierror)
    
    real(pr),intent(in) :: buffer(:)
    integer(pin),intent(in) :: count,datatype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Bcast_real_vector


  subroutine MPI_Reduce(sendbuf,recvbuf,count,datatype,op,root,comm,ierror)
    
    real(pr),intent(in) :: sendbuf
    real(pr),intent(out) :: recvbuf
    integer(pin),intent(in) :: count,datatype,op,root,comm
    integer(pin),intent(out) :: ierror

    recvbuf = sendbuf
    ierror = 0

  end subroutine MPI_Reduce


  subroutine MPI_Gatherv_real(sendbuf,sendcount,sendtype,recvbuf,recvcounts,displs,recvtype,root,comm,ierror)

    real(pr),intent(in) :: sendbuf(:),recvbuf(:)
    integer(pin),intent(in) :: sendcount,sendtype,recvcounts(:),displs(:),recvtype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Gatherv_real


  subroutine MPI_Gatherv_complex(sendbuf,sendcount,sendtype,recvbuf,recvcounts,displs,recvtype,root,comm,ierror)

    complex(pr),intent(in) :: sendbuf(:),recvbuf(:)
    integer(pin),intent(in) :: sendcount,sendtype,recvcounts(:),displs(:),recvtype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Gatherv_complex


  subroutine MPI_Scatterv_real(sendbuf,sendcounts,displs,sendtype,recvbuf,recvcount,recvtype,root,comm,ierror)

    real(pr),intent(in) :: sendbuf(:),recvbuf(:)
    integer(pin),intent(in) :: sendcounts(:),displs(:),sendtype,recvcount,recvtype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Scatterv_real


  subroutine MPI_Scatterv_complex(sendbuf,sendcounts,displs,sendtype,recvbuf,recvcount,recvtype,root,comm,ierror)

    complex(pr),intent(in) :: sendbuf(:),recvbuf(:)
    integer(pin),intent(in) :: sendcounts(:),displs(:),sendtype,recvcount,recvtype,root,comm
    integer(pin),intent(out) :: ierror

    ierror = 0

  end subroutine MPI_Scatterv_complex


end module mpi
